
import React from 'react';

class AXIS extends React.Component {

    constructor(props){
      super(props)
      console.log(props)
      this.renderD3Component = this.renderD3Component.bind(this)
    }
  
    renderD3Component(){ 
      console.log(this.node)
      if(this.props.xscale == 'ordinal'){
         let render = HorizontalOrdinalComponent(this.node,
                        { height: this.props.height,
                          width: this.props.width,
                          transform: this.props.transform,
                          offset: this.props['padding-left'],
                          padding: this.props.padding
                        })
            render(this.props.data)
         }
      else if(this.props.yscale == 'linear'){
        
         let render = VerticalLinearComponent(this.node,
                        { height: this.props.height,
                          width: this.props.width,
                          transform: this.props.transform,
                          offset: this.props['padding-left'],
                          padding: this.props.padding
                        })  
         render(this.props.data)
       }
      else if(this.props.yscale == 'ordinal'){
         let render =  VerticalOrdinalComponent(this.node,
                        { height: this.props.height,
                          width: this.props.width,
                          transform: this.props.transform,
                          offset: this.props['padding-left'],
                          padding: this.props.padding
                        })  
         render(this.props.data)
      }
      else if(this.props.xscale == 'linear'){
        let render =  HorizontalLinearComponent(this.node,
                        { height: this.props.height,
                          width: this.props.width,
                          transform: this.props.transform,
                          offset: this.props['padding-left'],
                          padding: this.props.padding
                        })
         render(this.props.data)
      }
    }
  
    componentDidMount(){
      this.renderD3Component()
    }
  
    componentDidUpdate(){
      this.renderD3Component()
    }
  
    render(){
      return <g  ref = { node => this.node = node }></g>;
    }

}

export default AXIS;

import { select, 
         scaleLinear,
         scaleOrdinal,
         scaleBand,
         max,
         axisLeft,
         axisBottom
       } 
from 'd3'; 

const HorizontalOrdinalComponent = (selection,props) => {

      const render = (data) => {
           selection = select(selection)
           data = props.transform(data)          
           
           const draw = () => {
             
                const scale = scaleBand().domain(data)
                													.range([0,props.width])
                                          .padding(props.padding? props.padding: 0.2)
                
                const axis = axisBottom(scale)
                
                selection.attr('transform',`translate(${props.offset},${props.height})`)
                          .append('g')
                         .call(axis)
             
            }
           
           draw()  
       }

      return render;
}

const VerticalLinearComponent = (selection,props) => {
             
       const render = data => {
       
            selection = select(selection)
            data = props.transform(data) 
         
            const draw = () => {
             
                const scale = scaleLinear().domain([max(data),0])
                													.range([0,props.width])
                
                
                const axis = axisLeft(scale)
                
                selection.attr('transform',`translate(${props.offset},0)`)
                          .append('g')
                         .call(axis)
             
            }
            draw()
       
       }
       return render;
}
 

const VerticalOrdinalComponent = (selection,props) => {

      const render = (data) => {
           selection = select(selection)
           data = props.transform(data)          
           
           const draw = () => {
             
                const scale = scaleBand().domain(data)
                													.range([0,props.width])
                                          .padding(props.padding? props.padding: 0.2)
                
                const axis = axisLeft(scale)
                
                selection.attr('transform',`translate(${props.offset},0)`)
                          .append('g')
                         .call(axis)
             
            }
           
           draw()  
       }

      return render;
}

const HorizontalLinearComponent = (selection,props) => {
             
       const render = data => {
       
            selection = select(selection)
            data = props.transform(data) 
         
            const draw = () => {
             
                const scale = scaleLinear().domain([0,max(data)])
                													.range([0,props.width])
                
                
                const axis = axisBottom(scale)
                
                selection.attr('transform',`translate(${props.offset},${props.height})`)
                          .append('g')
                         .call(axis)
             
            }
            draw()
       
       }
       return render;
}


