import React from 'react';


class Canvas extends React.Component {
   
   constructor(props){
     super(props)
     this.state = { data: undefined}
     this.props.children.forEach(x => {
       if(typeof(x.type) !== "string"){
         if(x.props.height === undefined)
         	x.props.height = props.height
         if(x.props.width === undefined)
         	x.props.width = props.width
       } 
     })
   }
  
   componentDidMount(){
     this.props.data.then( x => {
         if(x)this.setState({data:x})
     })  
   }
  
  
   render(){
     
     this.props.children.forEach(x => {
         x.props.data = this.state.data
     })
     
     if(this.state.data)
     return (<svg ref = { node => this.node = node }
                  height = {this.props.height} 
                  width = {this.props.width} >
               <g>
               {
                  this.props.children[0],
                  this.props.children[1],
                  this.props.children[2] 
               }
               </g>
            </svg>);
       else return <svg><text x = '0' y = '0'> loading </text></svg>;
     
     
   }
}

export default Canvas;